package com.company.timezonemysqlbug

import org.testcontainers.containers.MySQLContainer

class TestDatabaseContainer {

    val jdbcQueryString = "?useSSL=false&allowMultiQueries=true&serverTimezone=UTC&allowPublicKeyRetrieval=true"
    val jdbcUrl: String

    val username = "test"
    val password = "test"

    private val mysql = MySQLContainer<Nothing>("mysql:5.7").also {
        it.withUsername(username)
        it.withPassword(password)
        it.withEnv("MYSQL_ROOT_PASSWORD", password)
        it.withCommand(
            "--character-set-server=utf8mb4",
            "--collation-server=utf8mb4_unicode_ci"
        )
        it.withDatabaseName("test")
        it.withExposedPorts(3306)
        it.withReuse(true)
    }

    init {
        mysql.start()
        jdbcUrl = "jdbc:mysql://localhost:" + mysql.firstMappedPort + "/test" + jdbcQueryString
        System.setProperty("cuba.dataSource.jdbcUrl", jdbcUrl)
    }

}